
CoCoA-5 - Feature #996

New function: IdealOfGBasis

12 Jan 2017 17:11 - Anna Maria Bigatti

Status: Closed Start date: 12 Jan 2017

Priority: High Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: CoCoA-5 function: new Estimated time: 2.01 hours

Target version: CoCoA-5.2.0 spring 2017 Spent time: 1.40 hour

Description

Consider this case

I := ideal(.....);

G := GBasis(I);

J := ideal(G);

now, G is the GBasis of J, but J does not know it.  So GBasis(J) has to recompute it.    

I propose to add in (CoCoALib and) CoCoA-5 the function IdealOfGBasis(I) which does as above and sets the GBasis of the returned

value.

Related issues:

Related to CoCoALib - Feature #957: New function: HasGBasis Closed 27 Oct 2016

Related to CoCoALib - Bug #349: IdealOfPoints: gens are actually a GBasis Closed 18 May 2013

Related to CoCoA-5 - Feature #1017: New function: SetGBasisAsGens [--> NO: us... Rejected 02 Mar 2017

Related to CoCoA-5 - Design #1020: Rename minimalized(I) into IdealOfMinGens(I)? Closed 06 Mar 2017

Related to CoCoALib - Feature #1053: New function: IdealOfGBasis, IdealOfMinG... Closed 26 Apr 2017

History

#1 - 12 Jan 2017 17:11 - Anna Maria Bigatti

- Related to Feature #957: New function: HasGBasis added

#2 - 12 Jan 2017 17:11 - Anna Maria Bigatti

- Related to Bug #349: IdealOfPoints: gens are actually a GBasis added

#3 - 27 Jan 2017 08:05 - Anna Maria Bigatti

Asking for approval: is this name ok?

#4 - 02 Mar 2017 13:29 - Anna Maria Bigatti

- Related to Feature #1017: New function: SetGBasisAsGens [--> NO: use IdealOfGBasis] added

#5 - 06 Mar 2017 16:51 - Anna Maria Bigatti

- Related to Design #1020: Rename minimalized(I) into IdealOfMinGens(I)? added

#6 - 06 Mar 2017 17:41 - John Abbott

As I pointed out in #1020, this fn should also copy across any 3-way flags (e.g. IamRadical3) from the original ideal.

#7 - 06 Mar 2017 19:17 - Anna Maria Bigatti

John Abbott wrote:

As I pointed out in #1020, this fn should also copy across any 3-way flags (e.g. IamRadical3) from the original ideal.
oh, I guess you are right :-/

#8 - 08 Mar 2017 08:44 - Anna Maria Bigatti

John Abbott wrote:

As I pointed out in #1020, this fn should also copy across any 3-way flags (e.g. IamRadical3) from the original ideal.

 

After trying to do it, I realized I cannot.

You seemed against having IdealOfGBasis in CoCoALib, so I have no access to the flags.

They have to be set with care: for example, IhaveMonomialGens3Value should not be copied if false  (GBasis might be monomial)

#9 - 08 Mar 2017 18:43 - John Abbott

- Status changed from New to In Progress

I don't recall being opposed to the idea of having IdealOfGBasis (or something similar) in CoCoALib.

Now that you point out that not all flags can be simply copied, it seems potentially "safer" to have a function which makes a new ideal, rather than one

which "updates" an existing ideal.  When making a new ideal one has to copy explicitly those flags which are to be preserved; in constrast, when

"updating" an ideal one has to reset any flags which need this.  Human forgetfulness could lead to wasted computation in the first case (as some

"forgotten" flag is recomputed), whereas it might lead to an incorrectly set flag in the second case.

An annoying feature of creating a new ideal (and thus copying all relevant flags) is that adding more flags in the future would require updating the

"pseudo-copy-constructor" [though as I pointed out above, forgetting to do so will, in the worst case, just waste some recomputation].

#10 - 07 Apr 2017 09:56 - Anna Maria Bigatti

John Abbott wrote:

I don't recall being opposed to the idea of having IdealOfGBasis (or something similar) in CoCoALib.

 

Then should I move IdealOfGBasis and IdealOfMinGens from CoCoALibSupplement to SparsePolyRing?

#11 - 07 Apr 2017 09:57 - Anna Maria Bigatti
- Status changed from In Progress to Resolved

- % Done changed from 10 to 70

#12 - 07 Apr 2017 11:36 - John Abbott

OK to put IdealOfGBasis into SparsePolyRing.C assuming you are convinced that that is the right place.

What about something similar for Janet bases?

#13 - 19 Apr 2017 18:13 - John Abbott

Cosa dovrebbe fare il seguente?

IdealOfGBasis(ideal(zero(P)));

 

NOTE: problem came up when I did GroebnerFanIdeals(ideal(0,0))

#14 - 26 Apr 2017 18:02 - Anna Maria Bigatti

- Related to Feature #1053: New function: IdealOfGBasis, IdealOfMinGens in CoCoALib added

#15 - 27 Apr 2017 18:14 - Anna Maria Bigatti

- Status changed from Resolved to Feedback

- % Done changed from 70 to 90

John Abbott wrote:

Cosa dovrebbe fare il seguente?

 

fixed

#16 - 28 Apr 2017 09:12 - Anna Maria Bigatti

- Estimated time set to 2.01 h

#17 - 29 Apr 2017 08:34 - Anna Maria Bigatti

- Status changed from Feedback to Closed

- % Done changed from 90 to 100
